/***************************************************************************
                          KDBSearchEngine.cpp  -  description
                             -------------------
    begin                : Fri Sep 8 2000
    copyright            : (C) 2000-2003 by Andrea Rizzi
    email                : rizzi@kde.org
 ***************************************************************************/

/*
 Translation search engine


  Copyright  2000-2003
  Andrea Rizzi rizzi@kde.org

  License GPL v 2.0

*/

#include <kdebug.h>
#include "database.h"
#include "KDBSearchEngine2.h"
#include <kapplication.h>
#include <qpushbutton.h>

KDBSearchEngine2::KDBSearchEngine2(QObject *parent,const char*name)
 : SearchEngine(parent,name)
{
di=0;   //Database Interface

connect(this,SIGNAL(hasError(QString)),SLOT(setLastError(QString)));

  iAmReady=true;  //  I don't know if it is a good idea, no DB loaded!!!

//  scanInProgress=false;
  searching=false;
//  stopNow=false;

  
}


KDBSearchEngine2::~KDBSearchEngine2()
{
 if(di)
   delete di;
}

bool KDBSearchEngine2::startSearch(QString str)
{

/* if(autoUpdate)
   {
    updateSettings();
   }
*/
    
di->stop(true);
emit started();
kapp->processEvents(1000); //I hope this is ok to flush previous stops
    
if(searching) return false;
searching=true;
di->stop(false);

if(!init()) return false;
if(di->exactMatch(str).count()<5)
 if(di->alphaMatch(str).count()<5)
    {
    if(words(str).count()>1)
	di->wordsMatch(str).count();
    else
	di->correlation(str);
    }

di->stop(false);
searching=false;

emit finished();

return true;

}

bool KDBSearchEngine2::startSearchInTranslation(QString str)
{

 /*if(autoUpdate)
   {
    updateSettings();
   }
*/



 return true; 

}



bool KDBSearchEngine2::messagesForPackage(const QString& package
                         , QValueList<Message>& resultList, QString& error)
{

/*  int count = 0;
  stopNow=false; // Remove dirty.
  Message m;

  if(searching )
  {
   error=i18n("Another search has already been started");
   return false;
  }

  if(scanInProgress)
  {
   error=i18n("Unable to search now: a PO file scan is in progress");
   return false;
  }


  if(!openDb()) {
   error=i18n("Unable to open the database");
   return false;
  }

   if(totalRecord<=0)
     {
     error=i18n("Database empty");
     return false;
     }

   int step=(totalRecord/30)+1;
   int ntra,nref;
   int req=dm->searchCatalogInfo(package);
   if(req==-1) {
    error=i18n("No entry for this package in the database.");
    return false;
   }
   DataBaseItem item;
   int i,h;
   kdDebug(0) << "looking for catalog " << req <<endl;
   
   progressStarts(i18n("Searching for %1 in database").arg(package));

   for(item = dm->firstItem();!item.isNull();item=dm->nextItem())
   {
      count++;	       
      if(count%step==0){
           emit progress(100*count/totalRecord);
           kapp->processEvents(100);
         }
      if(stopNow) {
	stopNow=false;
	searching=false;
	emit finished();
	return true;	// No error, stopped!
      }
      
      ntra=item.numTra;
      for(i=0;i<ntra;i++) {
       nref=item.translations[i].numRef;

          for(h=0;h<nref;h++){
            if(item.translations[i].infoRef[h]==req) {
    		m.msgid=item.key;
    		m.msgstr=item.translations[i].translation;
		resultList.append(m);      	
	      }
    	  }
      }	  
       
   }
  */ 
   return true;
}


void  KDBSearchEngine2::setLastError(QString er)
{
lasterror=er;
}

QString KDBSearchEngine2::translate(const QString text)
{

return "boh";

   
}

//    void numberOfResultsChanged(int n);

    /**
     * signals, that the order of the results in the list has changed.
     * For example because a better matching string has been prepended.
     */
//    void resultsReordered();

    /**
     * signals, that a new result was found
     */
//    void resultFound(const SearchResult*);


void KDBSearchEngine2::receiveResult(QueryResult r)
{

SearchResult se;

se.translation=r.richResult();
se.found=r.richOriginal();

se.plainTranslation=r.result();
se.plainFound=r.original();
se.score=r.score();
emit resultFound(&se);

}


/*
    QString requested;
    QString found;
    QString translation;

    QString plainTranslation;

    QString plainFound;
    QString plainRequested;
    int score;
    QPtrList<TranslationInfo> descriptions;

*/



bool KDBSearchEngine2::init()
{
 if(di!=0) return true;
 else
  {
   di = new DataBaseInterface();
   connect(di,SIGNAL(newResult(QueryResult)),this,SLOT(receiveResult(QueryResult)));
   if(!di->mainOk()) return false; 
   
   return true;
  }

}
const KAboutData *KDBSearchEngine2::about() const
{

	return DbSe2Factory::instance()->aboutData();

}

void KDBSearchEngine2::stringChanged( QString orig, QString translated
                     , QString description)
{
		     
if(!init()) return;
//if(translated.isEmpty()) return;
InputInfo ii;
if(description.find("fuzzy",false)==-1)
 di->addEntry(orig,translated,&ii);
		     
}
PrefWidget * KDBSearchEngine2::preferencesWidget(QWidget *parent)
{

 pw =  new PreferencesWidget(parent);
 kdDebug(0) << "new pref" << endl;
// setSettings();
 connect(pw,SIGNAL(restoreNow()),this,SLOT(setSettings()));
 connect(pw,SIGNAL(applyNow()),this,SLOT(updateSettings()));
 connect(pw,SIGNAL(destroyed()),this,SLOT(prefDestr()));
 connect(pw->dbpw->scanPB_2,SIGNAL(clicked()),this,SLOT(scan()));
 connect(pw->dbpw->scanrecPB,SIGNAL(clicked()),this,SLOT(scanRecur()));
 connect(pw->dbpw->scanFilePB,SIGNAL(clicked()),this,SLOT(scanFile()));
 connect(pw->dbpw->repeatPB,SIGNAL(clicked()),this,SLOT(repeat()));


return pw;
}

#include "KDBSearchEngine2.moc"

